# All files / src/TieredDropdown TieredDropdown.helpers.ts

36.66% Statements 11/30
0% Branches 0/3
0% Functions 0/10
37.93% Lines 11/29

Press n or j to go to the next uncovered block, b, p or k for the previous block.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88

    2x

    2x

    2x

    2x

    2x

    2x

    2x

    2x

    2x

    2x

    2x

     import { Id } from '../TieredSelect/TieredSelect.types'

    export const empty: any[] = []

    export const hideKeys = {
      overlay: ['Escape', 'Esc'],
      target: ['Escape', 'Esc'],
    }

    export function defaultGetGroupId<
      T extends {
        groupId: Id
      }
    >(tier: T) {
      return tier.groupId
    }

    export function defaultGetId<
      T extends {
        id: Id
      }
    >(tier: T) {
      return tier.id
    }

    export function defaultGetLabel<T extends { label: string }>(tier: T) {
      return tier.label
    }

    export function defaultGetNextGroupId<T extends { nextGroupId?: Id }>(tier: T) {
      return tier.nextGroupId
    }

    export function defaultIsTierDisabled<T extends { disabled?: boolean }>(
      tier: T
    ) {
      return Boolean(tier.disabled)
    }

    export function noop() {}

    export function always() {
      return true
    }

    /**
     * Helper function to find path in tiered structure
     * @param optionsByNextGroupId
     * @param item
     * @param getGroupId
     * @param getNextGroupId
     * @returns
     */
    export function findPath<T>(
      optionsByNextGroupId: Record<string | number, any>,
      item: T,
      getGroupId: (t: T) => Id
    ) {
      const path: T[] = [item]
      let currentItem = item

      while (getGroupId(currentItem)) {
        const groupId = getGroupId(currentItem)
        if (groupId) {
          const parent = optionsByNextGroupId[groupId]
          path.push(parent)
          currentItem = parent
        } else {
          break
        }
      }

      return path.reverse()
    }

    /**
     * Helper function to generate a path key
     * @param path
     * @param getLabel
     * @returns
     */
    export function getPathKey<T>(
      Ipath: T[] = [],
      getLabel: (tier: T) => string | undefined
    ) {
      return path.map((node) => getLabel(node)).join(' > ')
    }